unit FlussDiagfenster;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Struktteile, Menus;


type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    Einfgen1: TMenuItem;
    Anweisung: TMenuItem;
    N1: TMenuItem;
    IfAnweisung: TMenuItem;
    N2: TMenuItem;
    WhileSchleife: TMenuItem;
    RepeatUntilSchleife: TMenuItem;
    ForSchleife: TMenuItem;
    Lschen1: TMenuItem;
    N3: TMenuItem;
    Anzeigeverkleinernvergrern1: TMenuItem;
    Textbearbeiten1: TMenuItem;
    InneuemFensteranzeigen1: TMenuItem;
    DoWhileSchleife: TMenuItem;
    Genauerbestimmen1: TMenuItem;
    constructor CreateWE(Owner:TComponent; s : TElement);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Einfuegen(Sender: TObject);
    procedure Loeschen(Sender: TObject);
    function Textbearbeiten(Sender: TObject):boolean;
    procedure InneuemFensteranzeigen(Sender: TObject);
    procedure AdjustScrollBars();
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ChangeDisplay(Sender: TObject);
    procedure ChangeMinimize(e:TElement);
    procedure DisplayStruktogramm(cv : TCanvas; pos: Tpoint );
    procedure PrintStruktogramm(cv : TCanvas);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Textbearbeiten1Click(Sender: TObject);
    procedure Genauerbestimmen1Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private-Deklarationen }
    Struktogramm : TElement;
    Options      : TDisplayOptions;
    MoveObject   : boolean;
  public
    { Public-Deklarationen }
    canClose     : boolean;
    function getTitel():string;
    procedure setStruktogramm (e : TElement);
    procedure checkValid(e : TElement);
  end;




implementation
uses Hauptfenster, Unit3;

{$R *.DFM}


// TForm1
// ---------


procedure TForm1.setStruktogramm(e:TElement);
begin
  Options.free();
  Options:= TDisplayOptions.Create();
  Struktogramm:= e;

  AdjustScrollBars();
  Repaint();
end;

procedure TForm1.checkValid(e:TElement);
begin
end;


function TForm1.getTitel(): string;
begin
  result := Struktogramm.Name;
end;



constructor TForm1.CreateWE(Owner: TComponent; s: TElement);
begin
  inherited Create(Owner);
  Struktogramm := s;
  MoveObject := false;
  Options := TDisplayOptions.Create();
  canClose := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  color := $02F5F5F5;
  AdjustScrollBars();
end;

procedure TForm1.AdjustScrollbars();
var gr : TSize;
begin
  gr := Struktogramm.getSize(canvas,Options);
  VertScrollBar.Range := gr.cy + 50;
  HorzScrollBar.Range := gr.cx + 50;
end;



procedure TForm1.FormPaint(Sender: TObject);
var pos : TPoint;
begin
  pos.y := 15;
  pos.x := Struktogramm.getSize(canvas,Options).cx div 2+30;
  pos.y := pos.y - VertScrollBar.Position;
  pos.x := pos.x - HorzScrollBar.Position;
  DisplayStruktogramm(canvas,pos);
end;

procedure TForm1.DisplayStruktogramm(cv : TCanvas; pos : TPoint);
begin
  if options.color then  cv.brush.color := $02F5F5F5
                   else  cv.brush.color := $02FFFFFF;

  cv.Ellipse(pos.x-2,pos.y-9,pos.x+3,pos.y-4);
  cv.moveTo(pos.x,pos.y-4);
  cv.LineTo(pos.x,pos.y);
  Options.Root := Struktogramm;
  Struktogramm.zeichnen(cv, pos, Options);
end;

procedure TForm1.PrintStruktogramm(cv : TCanvas);
var pos : TPoint;
begin
  cv.font.size:=12;
  cv.font.name:='Times New Roman';
  cv.TextOut(10,10,Caption);
  pos.y := 80;
  Options.color := false;
  Options.Pfeillaenge := cv.TextExtent('ja').cy div 2;
  Options.Printing := true;
  cv.Pen.Width:=3;
  pos.x := Struktogramm.getSize(cv,Options).cx div 2+30;
  DisplayStruktogramm(cv,pos);
  Options.Pfeillaenge := 6;
  Options.Printing := false;
  Options.color := true;
end;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pos : TPoint;
    selold, selnew : TElement;
begin
  if (ssLeft in Shift) or (ssRight in Shift) then
  begin
    pos.y := 15;
    pos.x := Struktogramm.getSize(canvas,Options).cx div 2+30;
    y := y + VertScrollBar.Position;
    x := x + HorzScrollBar.Position;
    selold := Options.getLastSelection();
    selnew := Struktogramm.GetSelection(canvas,pos,Options,x,y);
    if (selnew <> nil) and (selnew.movable) then MoveObject := True;
    if (selold <> selnew) then
    begin
      Options.DeselectAll();
      Options.Select(selnew);
      Repaint();
    end
  end;
  if (ssLeft in Shift) and (ssDouble in Shift) then
  begin
    MoveObject := False;
    TextBearbeiten(self);
  end;
end;

procedure TForm1.Einfuegen(Sender: TObject);
var e : TElement;
    Selection : TElement;
begin
  Selection := Options.getLastSelection();
  if Selection <> nil then
  begin
    e := nil;
    if (Sender = Anweisung) or (Sender = Form2.BAnweisung) or (Sender = Form2.Anweisung) then e := TAnweisung.Create('Anweisung');
    if (Sender = IfAnweisung) or (Sender = Form2.BIFAnweisung) or (Sender = Form2.IfAnweisung) then e := TIf.Create('???');
    if (Sender = WhileSchleife) or (Sender = Form2.BWhileSchleife) or (Sender = Form2.WhileSchleife) then e := TWhile.Create('???');
    if (Sender = RepeatUntilSchleife) or (Sender = Form2.BRepeatUntilSchleife) or (Sender = Form2.RepeatUntilSchleife) then e := TRepeat.Create('???');
    if (Sender = DoWhileSchleife) or (Sender = Form2.BDoWhileSchleife) or (Sender = Form2.DoWhileSchleife) then e := TDoWhile.Create('???');
    if (Sender = ForSchleife) or (Sender = Form2.BForSchleife) or (Sender = Form2.ForSchleife) then e := TFor.Create('???');

    if e<> nil then
    begin
      (Application.MainForm as TForm2).SaveKopie();
      Selection.insert(e);
      if (Selection is TBlock) and (Options.isMinimized(Selection)) then (Application.MainForm as TForm2).ChangeMinimize(Selection);
      Options.DeselectAll();
      Options.Select(e);
      (Application.MainForm as TForm2).RepaintChildren();
      if Textbearbeiten(self) then
      begin
        Loeschen(self);
        (Application.MainForm as TForm2).DeleteKopie();
        (Application.MainForm as TForm2).DeleteKopie();
      end;
      (Application.MainForm as TForm2).DeleteKopie();
      (Application.MainForm as TForm2).RepaintChildren();
    end;
  end;
end;

procedure TForm1.Loeschen(Sender: TObject);
var Selection : TElement;
begin
  Selection := Options.getLastSelection();
  if Selection <> nil then
  begin
    (Application.MainForm as TForm2).SaveKopie();
    Struktogramm.delete(Selection);
    Options.DeselectAll();
    if not (Selection is TBlock) then Selection.free;
    (Application.MainForm as TForm2).RepaintChildren();
  end;
end;

function TForm1.Textbearbeiten(Sender: TObject):boolean;
var Selection : TElement;
    abb : boolean;
begin
  abb := false;
  Selection := Options.getLastSelection();
  if Selection <> nil then
  begin
    (Application.MainForm as TForm2).SaveKopie();
    if (Selection is TAnweisung) then
       abb := not InputQuery('Anweisung','Gib eine neue Anweisung ein:',Selection.Name);
    if (Selection is TIf) then
       abb := not InputQuery('If-Anweisung','Gib eine neue Bedingung ein:',Selection.Name);
    if (Selection is TFor) then
    begin
       Form3.SetString(Selection.Name);
       abb := (Form3.ShowModal()=-1);
       Selection.Name := Form3.s;
    end
    else
      if (Selection is TWhile) then
         abb := not InputQuery('Schleife','Gib eine neue Bedingung ein:',Selection.Name);
    if (Selection is TBlock) then
    begin
       abb := not InputQuery('Anweisungsblock','Gib eine neue Bezeichnung ein:',Selection.Name);
      (Application.MainForm as TForm2).RenameChildren();
    end;
    (Application.MainForm as TForm2).RepaintChildren();
  end;
  result:=abb;
end;

procedure TForm1.InneuemFensteranzeigen(Sender: TObject);
var nf : TForm1;
   Selection : TElement;
begin
  Selection := Options.getLastSelection();
  if Selection <> nil then
  begin
    if Selection is TBlock then
    begin
      nf := TForm1.CreateWE(parent,Selection);
      nf.Caption := Selection.Name;
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if canClose then
  begin
    Options.free();
    action := caFree;
  end;
end;

procedure TForm1.ChangeDisplay(Sender: TObject);
var Selection : TElement;
begin
  Selection := Options.getLastSelection();
  if (Selection is TBlock) then changeMinimize(Selection);
end;

procedure TForm1.ChangeMinimize(e:TElement);
begin
  Options.changeMinimize(e);
  Repaint; AdjustScrollBars();
  if (Options.SelectedPos.bottom-Options.SelectedPos.top>Height) then
    VertScrollBar.Position := Options.SelectedPos.top+ VertScrollBar.Position-2
  else
    VertScrollBar.Position := (Options.SelectedPos.top + Options.SelectedPos.bottom) div 2 + VertScrollBar.Position-Height DIV 2;

  HorzScrollBar.Position := (Options.SelectedPos.left + Options.SelectedPos.right) div 2 + HorzScrollBar.Position-Width DIV 2;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var Selection : TElement;
    done : boolean;
begin
  Selection := Options.getLastSelection();
  case key of
    VK_DELETE: Loeschen(Sender);
    VK_INSERT: Einfuegen(Anweisung);
    VK_RETURN:  TextBearbeiten(Sender);
    VK_DOWN:
    begin
      done := false;
      if (Selection=nil) then Selection := Struktogramm;
      if (Selection is TBlock) then
      begin
        if (Selection as TBlock).elemente <> nil then
        begin
          Options.DeselectAll();
          Options.Select((Selection as TBlock).elemente);
          done := true;
        end;
      end;
      if (not done) then
      begin
        repeat
        if Selection.next <> nil then
        begin
          Options.DeselectAll();
          Options.Select(Selection.next);
          done := true;
        end
        else
        begin
          repeat
            Selection := Struktogramm.FindPrevious(Selection);
          until (Selection is TBlock);
        end;
        until done or (Selection = Struktogramm);

      end;
      (Application.MainForm as TForm2).RepaintChildren();
    end;
    VK_UP:
    begin
      if (Selection <> nil) and (Selection<>Struktogramm) then
      begin
        Options.DeselectAll();
        Options.Select(Struktogramm.findPrevious(Selection));
        Repaint();
      end;
    end;
    VK_LEFT:
    begin
      if (Selection is TBedingung) then
      begin
        Options.DeselectAll();
        Options.Select((Selection as TBedingung).Block[1]);
        Repaint();
      end;
    end;
    VK_RIGHT:
    begin
      if (Selection is TBedingung) then
      begin
        Options.DeselectAll();
        if (Selection as TBedingung).AnzBlocks > 1 then
          Options.Select((Selection as TBedingung).Block[2])
        else
          Options.Select((Selection as TBedingung).Block[1]);
        Repaint();
      end;
    end;


  end;

end;

procedure TForm1.Textbearbeiten1Click(Sender: TObject);
begin
  TextBearbeiten(sender);
end;

procedure TForm1.Genauerbestimmen1Click(Sender: TObject);
var Selection : TElement;
    neu : TBlock;
begin
  Selection := Options.getLastSelection();
  if (Selection is TAnweisung) then
  begin
    (Application.MainForm as TForm2).SaveKopie();
    neu := TBlock.Create(Selection.name);
    neu.next := Selection.next;
    Selection.next := neu;
    Loeschen(self);
    Options.DeselectAll();
    Options.Select(neu);
    ChangeDisplay(self);
    InneuemFensteranzeigen(self);
    (Application.MainForm as TForm2).RepaintChildren();
  end
  else
    if (Selection is TBlock) then
      InneuemFensterAnzeigen(self)
    else
      MessageDlg('Nur Anweisungen knnen genauer spezifiziert werden', mtError, [mbOk],0);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pos : TPoint;
    selold, selnew : TElement;
begin
  Options.MovePos := nil;
  if MoveObject then
  begin
    pos.y := 15;
    pos.x := Struktogramm.getSize(canvas,Options).cx div 2+30;
    y := y + VertScrollBar.Position;
    x := x + HorzScrollBar.Position;
    selold := Options.getLastSelection();
    selnew := Struktogramm.GetSelection(canvas,pos,Options,x,y);

    if (selnew <> nil) and (selold <> selnew) and (selnew.next <> selold) then
    begin
      (Application.MainForm as TForm2).SaveKopie();
      Struktogramm.remove(selold);
      if (Options.MoveBlockAfter) then
      begin
        selold.next := selnew.next;
        selnew.next := selold;
      end
      else
        selnew.insert(selold);
      (Application.MainForm as TForm2).RepaintChildren();
    end
    else
      if (selnew <> nil) and (not Options.MoveBlockAfter) and (selnew is TBlock) and (selold <> selnew) then
      begin
        if (selnew as TBlock).elemente <> selold then
        (Application.MainForm as TForm2).SaveKopie();
        Struktogramm.remove(selold);
        if (Options.MoveBlockAfter) then
        begin
          selold.next := selnew.next;
          selnew.next := selold;
        end
        else
          selnew.insert(selold);
       (Application.MainForm as TForm2).RepaintChildren();
      end
  end;
  MoveObject := False;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var pos : TPoint;
    selold, selnew : TElement;
begin
  if MoveObject then
  begin
    pos.y := 15;
    pos.x := Struktogramm.getSize(canvas,Options).cx div 2+30;
    y := y + VertScrollBar.Position;
    x := x + HorzScrollBar.Position;
    selold := Options.getLastSelection();
    selnew := Struktogramm.GetSelection(canvas,pos,Options,x,y);
    if (selnew is TBlock) then
    begin
      if (selold = selnew)
        or (Options.MoveBlockAfter and (selnew.next = selold))
        or ((not Options.MoveBlockAfter) and ((selnew as TBlock).elemente = selold)) then
          selnew := nil;
    end
    else
    begin
      if (selnew = nil) or (selold = selnew) or (selnew.next = selold) then
      begin
        selnew := nil;
      end;
    end;
    if (Options.MovePos <> selnew) then
    begin
      Options.MovePos := selnew;
      Repaint();
    end;
  end;
end;

end.
